## dde-control-center 6.0.78.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

set(DVERSION "6.0.44" CACHE STRING "define project version")
set(BUILD_DOCS OFF CACHE BOOL "Generate doxygen-based documentation")

set(PROJECT_NAME dde-control-center)
project(${PROJECT_NAME}
    VERSION ${DVERSION}
    DESCRIPTION "Deepin Control Center"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dde-control-center"
    LANGUAGES CXX C
)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
option(ENABLE_ASAN "Enable asan" OFF)
option(BUILD_TESTING "UNIT test" OFF)
set(BUILE_EXAMPLES OFF)

# dcc-v23
set(BUILD_DCC_OLD ON)
if (BUILD_DCC_OLD)
    add_subdirectory(dcc-old)
endif()

set(QT_NS Qt6)
set(DTK_NS Dtk6)
set(ASQT_NS AppStreamQt)

# 设置静态库文件目录
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
# 动态库文件目录
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
# 可执行文件目录
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)


# INFO:
# plugins can be disabled and their options
# plugin-authentication : DISABLE_AUTHENTICATION
# plugin-update : DISABLE_UPDATE
# plugin-keyboard: DISABLE_LANGUAGE to disable language panel

option(DISABLE_AUTHENTICATION "disable build authentication plugins" OFF)
option(DISABLE_UPDATE "disable build update plugins" OFF)
option(DISABLE_LANGUAGE "disable lanugage settings in control center" OFF)
option(USE_DEEPIN_ZONE "enable special timezone file on deepin" OFF)
option(DISABLE_SOUND_ADVANCED "disable sound advanced settings" OFF)
set(DEEPIN_TIME_ZONE_PATH "/usr/share/dde/zoneinfo/zone1970.tab" CACHE STRING "deepin timezone path")
set(LOCALE_I18N_PATH "/usr/share/i18n/SUPPORTED" CACHE STRING "Supported locale path")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/misc;${CMAKE_MODULE_PATH};${ECM_MODULE_PATH};${PROJECT_SOURCE_DIR}/misc")
include(DdeControlCenterPluginMacros)

# asan 自己有内存泄露，暂不使用
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(UNITTEST ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Werror=return-type -fno-omit-frame-pointer -Wextra")
    if(ENABLE_ASAN)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
        add_definitions(-DUSE_ASAN)
    endif()
else()
    # generate qm
    execute_process(COMMAND bash "misc/translate_generation.sh" "${CMAKE_CURRENT_BINARY_DIR}/src/dde-control-center"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
    # generate desktop translate
    execute_process(COMMAND bash "misc/translate_ts2desktop.sh"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif()

if (BUILD_TESTING)
    set(UNITTEST ON)
endif()

set(BUILD_PLUGIN ON)

if (NOT BUILD_PLUGIN)
    set(UNITTEST OFF)
endif()
# GNU 默认

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(UT_COMPILER -fprofile-arcs -ftest-coverage)
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(UT_COMPILER -fprofile-instr-generate -ftest-coverage)
endif()

if (USE_DEEPIN_ZONE)
    add_definitions(-DUSE_DEEPIN_ZONE)
    add_definitions(-DDEEPIN_TIME_ZONE_PATH="${DEEPIN_TIME_ZONE_PATH}")
endif ()

add_definitions(-DLOCALE_I18N_PATH="${LOCALE_I18N_PATH}")

# 增加安全编译参数
ADD_DEFINITIONS(${SAFE_COMPILER})

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(GoogleTest)

if(BUILD_DOCS)
    add_subdirectory(docs)
endif()

set(DCC_TRANSLATION_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/translations/v1.0" CACHE STRING "Install dir for dde-control-center translate files")

# 输出目录
set(DCC_LIBDIR ${PROJECT_BINARY_DIR}/lib)
# 插件目录
set(DCC_PLUGINS_DIR plugins_v1.0)
# 安装目录
set(DCC_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/dde-control-center)
set(DCC_DEBUG_LIBDIR ${DCC_INSTALL_DIR})
set(DCC_TRANSLATE_READ_DIR ${CMAKE_INSTALL_PREFIX}/${DCC_TRANSLATION_INSTALL_DIR})

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(DCC_DEBUG_LIBDIR ${DCC_LIBDIR})
    set(DCC_TRANSLATE_READ_DIR ${PROJECT_BINARY_DIR}/src/dde-control-center)
endif()

add_definitions(-DTRANSLATE_READ_DIR="${DCC_TRANSLATE_READ_DIR}")
# 插件安装目录
set(DCC_PLUGINS_INSTALL_DIR ${DCC_DEBUG_LIBDIR}/${DCC_PLUGINS_DIR} CACHE STRING "Install dir for dde-control-center plugins")
# 插件读取目录
set(MODULE_READ_DIR "${DCC_DEBUG_LIBDIR}" CACHE STRING "Dir to find dde-control-center modules")
set(PLUGINS_READ_DIR "${DCC_PLUGINS_INSTALL_DIR}" CACHE STRING "Dir to find dde-control-center plugins")

GNUInstallDirs_get_absolute_install_dir(
    MODULE_READ_FULL_DIR
    MODULE_READ_DIR
    LIBDIR
)

GNUInstallDirs_get_absolute_install_dir(
    PLUGINS_READ_FULL_DIR
    PLUGINS_READ_DIR
    LIBDIR
)

message(STATUS ${MODULE_READ_FULL_DIR})
message(STATUS ${PLUGINS_READ_FULL_DIR})
message(STATUS ${DCC_PLUGINS_INSTALL_DIR})

add_definitions(-DDefaultModuleDirectory="${MODULE_READ_FULL_DIR}")
add_definitions(-DDefaultPluginsDirectory="${PLUGINS_READ_FULL_DIR}")

# DdeControlCenterPluginMacros.cmake 使用
set(DDE_CONTROL_CENTER_PLUGIN_DIR ${DCC_PLUGINS_DIR})
set(DDE_CONTROL_CENTER_TRANSLATION_INSTALL_DIR ${DCC_TRANSLATION_INSTALL_DIR})
set(DDE_CONTROL_CENTER_PLUGIN_INSTALL_DIR ${DCC_PLUGINS_INSTALL_DIR})

set(LOCALSTATE_READ_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}" CACHE STRING "Dir to find modifiable single-machine data")
set(DCC_PROJECT_ROOT_DIR ${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DVARDIRECTORY="${LOCALSTATE_READ_DIR}")
# Find the library
find_package(PkgConfig REQUIRED)
find_package(${DTK_NS} REQUIRED COMPONENTS Core Gui  )
find_package(${QT_NS} COMPONENTS Core Quick Gui Network DBus Concurrent Test LinguistTools Multimedia REQUIRED)
find_package(GTest REQUIRED)
find_package(Threads REQUIRED)

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

# dconfig
file(GLOB DCONFIG_FILES "misc/configs/*.json")
dtk_add_config_meta_files(APPID org.deepin.dde.control-center BASE misc/configs FILES ${DCONFIG_FILES})
file(GLOB DCONFIG_FILE_REGION_FORMAT "misc/configs/common/org.deepin.region-format.json")
dtk_add_config_meta_files(COMMONID true FILES ${DCONFIG_FILE_REGION_FORMAT})

include_directories(
    include
)

set(Test_Libraries
    -lgcov
    Threads::Threads
    GTest::gtest
    ${QT_NS}::Test
)

set(DCC_FRAME_Library dde-control-center_frame)

add_subdirectory(src/dde-control-center)
#--------------------------plugins--------------------------
add_subdirectory(src/plugin-accounts)
add_subdirectory(src/plugin-sound)
add_subdirectory(src/plugin-defaultapp)
add_subdirectory(src/plugin-power)
add_subdirectory(src/plugin-mouse)
add_subdirectory(src/plugin-personalization)
add_subdirectory(src/plugin-keyboard)
add_subdirectory(src/plugin-systeminfo)
add_subdirectory(src/plugin-commoninfo)
add_subdirectory(src/plugin-touchscreen)
add_subdirectory(src/plugin-datetime)
add_subdirectory(src/plugin-wacom)
add_subdirectory(src/plugin-bluetooth)
add_subdirectory(src/plugin-update)
add_subdirectory(src/plugin-notification)
add_subdirectory(src/plugin-deepinid)
add_subdirectory(src/plugin-display)

if(BUILE_EXAMPLES)
    add_subdirectory(examples)
endif()

if(UNITTEST)
    add_subdirectory(tests)
endif()

=== src/dde-control-center/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

#--------------------------frame--------------------------
set(DCCFrame_Name ${DCC_FRAME_Library})
file(GLOB DCCFrame_SRCS
    "${DCC_PROJECT_ROOT_DIR}/include/*.h"
    "frame/*.cpp"
)

add_library(${DCCFrame_Name} SHARED
    ${DCCFrame_SRCS}
)

find_package(${QT_NS} COMPONENTS QmlModels REQUIRED)
set(DCCFrame_Libraries
    ${DTK_NS}::Gui
    ${QT_NS}::Gui
    ${QT_NS}::Quick
    ${QT_NS}::QmlModelsPrivate
)

target_link_libraries(${DCCFrame_Name} PRIVATE
    ${DCCFrame_Libraries}
)

set_target_properties(${DCCFrame_Name} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    OUTPUT_NAME dde-control-center
    EXPORT_NAME Control-Center
)

install(TARGETS ${DCCFrame_Name}
        EXPORT DdeControlCenterTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center
)

install(EXPORT DdeControlCenterTargets
        FILE DdeControlCenterTargets.cmake
        NAMESPACE Dde::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
)
#--------------------------qml-plugin--------------------------
add_subdirectory(frame/plugin)
#--------------------------dde-control-center--------------------------
set(Control_Center_Name dde-control-center)
file(GLOB Control_Center_SRCS
    "*.h"
    "*.cpp"
)
if (BUILD_DCC_OLD)
    add_library(${Control_Center_Name} SHARED
        ${Control_Center_SRCS}
        qrc/dcc.qrc
    )
    set_target_properties(${Control_Center_Name} PROPERTIES
        OUTPUT_NAME dde-control-center-lib
    )
else()
    add_executable(${Control_Center_Name}
        ${Control_Center_SRCS}
        qrc/dcc.qrc
    )
endif()

target_compile_definitions(${Control_Center_Name} PRIVATE CVERSION="${CMAKE_PROJECT_VERSION}")

target_include_directories(${Control_Center_Name} PRIVATE
    include/interface
    frame
)

set(Control_Center_Libraries
    ${DCC_FRAME_Library}
    ${DTK_NS}::Gui
    ${QT_NS}::Gui
    ${QT_NS}::DBus
    ${QT_NS}::Concurrent
    ${QT_NS}::Quick
)

target_link_libraries(${Control_Center_Name} PRIVATE
    ${Control_Center_Libraries}
)

file(GLOB_RECURSE qmlFiles  "${DCC_PROJECT_ROOT_DIR}/qml/*.*")
add_custom_target(${Control_Center_Name}_qml ALL
    SOURCES ${qmlFiles}
)
add_custom_command(TARGET ${Control_Center_Name}_qml
    COMMAND ${CMAKE_COMMAND} -E copy_directory "${DCC_PROJECT_ROOT_DIR}/qml" ${DCC_LIBDIR}
)

file(GLOB_RECURSE DCC_Translation_QML_FILES ${DCC_PROJECT_ROOT_DIR}/qml/*.qml ${DCC_PROJECT_ROOT_DIR}/src/*.qml)
file(GLOB_RECURSE DCC_Translation_SOURCE_FILES ${DCC_PROJECT_ROOT_DIR}/src/*.cpp ${DCC_PROJECT_ROOT_DIR}/src/*.h)
dcc_handle_plugin_translation(NAME ${Control_Center_Name} SOURCE_DIR ${DCC_PROJECT_ROOT_DIR} QML_FILES ${DCC_Translation_QML_FILES} SOURCE_FILES ${DCC_Translation_SOURCE_FILES})
# bin
if (BUILD_DCC_OLD)
    install(TARGETS ${Control_Center_Name} DESTINATION ${DCC_DEBUG_LIBDIR})
else()
    install(TARGETS ${Control_Center_Name} DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()
install(DIRECTORY "${DCC_PROJECT_ROOT_DIR}/qml/" DESTINATION ${DCC_INSTALL_DIR})
#----------------------------install config------------------------------
#desktop
install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.control-center.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

#service
configure_file(
    ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.ControlCenter1.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
    @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dbus-1/services)

# systemd service
if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Systemd REQUIRED systemd)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
endif()

configure_file(
    ${CMAKE_SOURCE_DIR}/misc/systemd/dde-control-center.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
    @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
        DESTINATION ${SYSTEMD_USER_UNIT_DIR})

# dev files
file(GLOB HEADERS "${DCC_PROJECT_ROOT_DIR}/include/*")
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center)
install(FILES ${HEADERS} DESTINATION ${INCLUDE_INSTALL_DIR})
if (BUILD_DCC_OLD)
    configure_package_config_file(${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterConfigOld.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
        PATH_VARS INCLUDE_INSTALL_DIR
        INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
else()
    configure_package_config_file(${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterConfig.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
        PATH_VARS INCLUDE_INSTALL_DIR
        INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
endif()

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfigVersion.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter)

install(FILES "${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterPluginMacros.cmake" DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter)

install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.controlcenter.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

#dde-grand-search-daemon conf
install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde-grand-search.dde-control-center-setting.conf
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-grand-search-daemon/plugins/searcher)

=== src/plugin-accounts/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(pluginName accounts)
file(GLOB_RECURSE accounts_SRCS
    "operation/*.cpp"
    "operation/*.h"
    "operation/qrc/${pluginName}.qrc"
)

add_library(${pluginName} MODULE
    ${accounts_SRCS}
)

pkg_check_modules(DEEPIN_PW_CHECK REQUIRED libdeepin_pw_check)

find_package(PolkitQt6-1)
set(accounts_Libraries
    dde-control-center
    ${QT_NS}::DBus
    ${DTK_NS}::Core
     ${DTK_NS}::Gui
     ${QT_NS}::Concurrent
     PolkitQt6-1::Agent
     ${DEEPIN_PW_CHECK_LIBRARIES}
)

target_link_libraries(${pluginName} PRIVATE
    ${accounts_Libraries}
)

dcc_install_plugin(NAME ${pluginName} TARGET ${pluginName})

=== src/plugin-datetime/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(pluginName datetime)
file(GLOB_RECURSE datetime_SRCS
    "operation/*.cpp"
    "operation/*.h"
    "operation/timezoneMap/*.h"
    "operation/timezoneMap/*.cpp"
    "operation/qrc/datetime.qrc"
)

add_library(${pluginName} MODULE
    ${datetime_SRCS}
)

find_package(ICU COMPONENTS i18n uc)

set(dateTime_Libraries
    ${DCC_FRAME_Library}
    ${QT_NS}::DBus
    ${QT_NS}::Concurrent
     ${DTK_NS}::Gui
     ICU::i18n
     ICU::uc
)

target_link_libraries(${pluginName} PRIVATE
    ${dateTime_Libraries}
)

dcc_install_plugin(NAME ${pluginName} TARGET ${pluginName})

=== src/plugin-deepinid/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(pluginName deepinid)
file(GLOB_RECURSE deepinid_SRCS
    "operation/*.cpp"
    "operation/*.h"
    "operation/qrc/deepinid.qrc"
)

add_library(${pluginName} MODULE
    ${deepinid_SRCS}
)

set(deepinid_Libraries
    ${DCC_FRAME_Library}
    ${QT_NS}::DBus
    ${QT_NS}::Concurrent
    ${DTK_NS}::Gui
)

target_link_libraries(${pluginName} PRIVATE
    ${deepinid_Libraries}
)

dcc_install_plugin(NAME ${pluginName} TARGET ${pluginName})

=== src/plugin-defaultapp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(DefaultApp_Name defaultapp)
file(GLOB_RECURSE defaultapp_SRCS
    "operation/*.cpp"
)

add_library(${DefaultApp_Name} MODULE
    ${defaultapp_SRCS}
)

set(DefaultApp_Libraries
    ${DCC_FRAME_Library}
    ${QT_NS}::DBus
)

target_link_libraries(${DefaultApp_Name} PRIVATE
    ${DefaultApp_Libraries}
)

dcc_install_plugin(NAME ${DefaultApp_Name} TARGET ${DefaultApp_Name})

=== src/plugin-display/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
###########################################
function(ws_generate_local type input_file output_name)
    pkg_get_variable(WAYLAND_SCANNER wayland-scanner wayland_scanner)
    execute_process(COMMAND ${WAYLAND_SCANNER}
        ${type}-header
        ${input_file}
        ${CMAKE_CURRENT_BINARY_DIR}/${output_name}.h
    )

    execute_process(COMMAND ${WAYLAND_SCANNER}
        public-code
        ${input_file}
        ${CMAKE_CURRENT_BINARY_DIR}/${output_name}.c
    )
endfunction()

find_package(PkgConfig REQUIRED)
pkg_check_modules(WaylandClient REQUIRED IMPORTED_TARGET wayland-client)

ws_generate_local(client
    ${CMAKE_CURRENT_SOURCE_DIR}/wayland/libwayqt/protocols/wlr-output-management-unstable-v1.xml
    wlr-output-management-unstable-v1-client-protocol)

ws_generate_local(client
    ${CMAKE_CURRENT_SOURCE_DIR}/wayland/libwayqt/protocols/treeland-output-management.xml
    treeland-output-management-client-protocol)

file(GLOB_RECURSE LIBWAYQT_SRCS
    "wayland/libwayqt/*.cpp"
    "wayland/libwayqt/*.hpp"
)

add_library(libwayqt6
    OBJECT
    ${LIBWAYQT_SRCS}
    wlr-output-management-unstable-v1-client-protocol.c
    treeland-output-management-client-protocol.c
)

# fix arm64 build failed relocation R_AARCH64_ADR_PREL_PG_HI21 against symbol
target_compile_options(libwayqt6 PRIVATE "-fpic")

target_include_directories(libwayqt6
    PUBLIC
        "${CMAKE_CURRENT_SOURCE_DIR}/wayland/libwayqt"
    PRIVATE
        ${Qt6Gui_PRIVATE_INCLUDE_DIRS}
)

target_link_libraries(libwayqt6
    PUBLIC
    ${QT_NS}::Core
    ${QT_NS}::Gui
    PkgConfig::WaylandClient
)
###########################################
set(Display_Name display)
file(GLOB_RECURSE Display_SRCS
    "operation/*.cpp"
)

add_library(${Display_Name} MODULE
    ${Display_SRCS}
)

target_include_directories(${Display_Name} PUBLIC
    $<TARGET_PROPERTY:libwayqt6,INTERFACE_INCLUDE_DIRECTORIES>
)

set(Display_Libraries
    ${DCC_FRAME_Library}
    ${QT_NS}::Gui
    ${QT_NS}::DBus
    ${DTK_NS}::Core
)

target_link_libraries(${Display_Name} PRIVATE
    ${Display_Libraries}
    $<TARGET_OBJECTS:libwayqt6>
    PkgConfig::WaylandClient
)

dcc_install_plugin(NAME ${Display_Name} TARGET ${Display_Name})
#########################################

=== src/plugin-keyboard/CMakeLists.txt ===
if (BUILD_PLUGIN)
    set(Plugin_Name keyboard)
    file(GLOB_RECURSE keyboard_SRCS
        "operation/*.h"
        "operation/*.cpp"
        "operation/qrc/keyboard.qrc"
    )
    file(GLOB_RECURSE keyboard_qml_SRCS
        "qml/*.qml"
    )
    # pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)
    add_library(${Plugin_Name} MODULE
        ${keyboard_SRCS}
    )

    set(keyboard_Includes
        src/plugin-keyboard/operation
    )
    set(keyboard_Libraries
        ${DCC_FRAME_Library}
        ${DTK_NS}::Gui
        ${QT_NS}::DBus
        ${QT_NS}::Gui
        ${QT_NS}::Qml
    )
    target_include_directories(${Plugin_Name} PUBLIC
        ${keyboard_Includes}
    )
    target_link_libraries(${Plugin_Name} PRIVATE
        ${keyboard_Libraries}
    )
    dcc_install_plugin(NAME ${Plugin_Name} TARGET ${Plugin_Name})
    # dcc_handle_plugin_translation(NAME ${Plugin_Name}  QML_FILES ${keyboard_qml_SRCS} SOURCE_FILES ${keyboard_SRCS})
endif()

=== src/plugin-notification/CMakeLists.txt ===
set(QT_VERSION_MAJOR "6")
find_package(Dtk6 REQUIRED COMPONENTS Tools) # for ${DTK_XML2CPP} which provides the path of `qdbusxml2cpp-fix` binary

if (BUILD_PLUGIN)

    set(notification_Name notification)
    file(GLOB_RECURSE notification_SRCS
        "operation/*.cpp"
        "operation/*.h"
        "types/*.h"
        "operation/qrc/notification.qrc"
    )
    file(GLOB_RECURSE notification_qml_SRCS
        "qml/*.qml"
    )
    find_package(${QT_NS} COMPONENTS Concurrent REQUIRED COMPONENTS Qml)

    set_source_files_properties(
        ${CMAKE_CURRENT_SOURCE_DIR}/operation/xml/org.desktopspec.ApplicationManager1.Application.xml
        PROPERTIES  INCLUDE types/am.h
                    CLASSNAME AppManager1Application
    )

    set_source_files_properties(
        ${CMAKE_CURRENT_SOURCE_DIR}/operation/xml/org.desktopspec.ObjectManager1.xml
        PROPERTIES  INCLUDE types/am.h
                    CLASSNAME AppManager1ApplicationObjectManager
    )

    qt_add_dbus_interfaces(
        DBUS_INTERFACES
        ${CMAKE_CURRENT_SOURCE_DIR}/operation/xml/org.desktopspec.ApplicationManager1.Application.xml
    )

    qt_add_dbus_interfaces(
        DBUS_INTERFACES
        ${CMAKE_CURRENT_SOURCE_DIR}/operation/xml/org.desktopspec.ObjectManager1.xml
    )

    add_library(${notification_Name} MODULE
        ${notification_SRCS}
        ${DBUS_INTERFACES}
    )

    set(notification_Includes
        src/plugin-notification/operation
        src/plugin-notification
        ${PROJECT_BINARY_DIR}/src/plugin-notification
    )
    set(notification_Libraries
        ${DTK_NS}::Gui
        ${QT_NS}::DBus
        ${QT_NS}::Concurrent
    )
    target_include_directories(${notification_Name} PUBLIC
        ${notification_Includes}
    )
    target_link_libraries(${notification_Name} PRIVATE
        ${notification_Libraries}
    )

    dcc_install_plugin(NAME ${notification_Name} TARGET ${notification_Name})
endif()

=== src/plugin-power/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(Power_Name power)
file(GLOB_RECURSE power_SRCS
    "operation/*.cpp"
    "operation/*.h"
    "operation/qrc/power.qrc"
)

add_library(${Power_Name} MODULE
    ${power_SRCS}
)

set(Power_Libraries
    ${DCC_FRAME_Library}
    ${DTK_NS}::Gui
    ${QT_NS}::DBus
    ${QT_NS}::Concurrent
)

target_link_libraries(${Power_Name} PRIVATE
    ${Power_Libraries}
)

dcc_install_plugin(NAME ${Power_Name} TARGET ${Power_Name})

=== src/plugin-sound/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(Sound_Name sound)
file(GLOB_RECURSE Sound_SRCS
    "operation/*.cpp"
    "operation/qrc/sound.qrc"
)

add_library(${Sound_Name} MODULE
    ${Sound_SRCS}
    operation/soundInteraction.cpp
    operation/soundInteraction.h
    operation/soundDeviceModel.cpp
    operation/soundDeviceModel.h
    operation/soundDeviceData.cpp
    operation/soundDeviceData.h
    operation/port.cpp
    operation/port.h
    operation/audioservermodel.cpp
)

if (DISABLE_SOUND_ADVANCED)
    target_compile_definitions(${Sound_Name} PUBLIC -DDCC_DISABLE_SOUND_ADVANCED)
endif()

set(Sound_Libraries
    ${DCC_FRAME_Library}
    ${DTK_NS}::Gui
    ${QT_NS}::DBus
    ${QT_NS}::Multimedia
)

target_link_libraries(${Sound_Name} PRIVATE
    ${Sound_Libraries}
)

dcc_install_plugin(NAME ${Sound_Name} TARGET ${Sound_Name})
# QML_ROOT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/plugin-sound/qml)

=== src/plugin-update/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(Update_Name update)
file(GLOB_RECURSE update_SRCS
        "operation/*.cpp"
        "operation/*.h"
        "operation/qrc/update.qrc"
)

add_library(${Update_Name} MODULE
        ${update_SRCS}
    )

set(Update_Libraries
        dde-control-center
        ${QT_NS}::DBus
        ${DTK_NS}::Gui
        ${QT_NS}::Concurrent
)

target_link_libraries(${Update_Name} PRIVATE
        ${Update_Libraries}
)

dcc_install_plugin(NAME ${Update_Name} TARGET ${Update_Name})

=== debian/changelog ===
dde-control-center (6.0.78.1) unstable; urgency=medium

  * 6.0.78.1

 -- Wang Fei <wangfei@deepin.org>  Mon, 16 Dec 2024 11:03:25 +0800

dde-control-center (6.0.78) unstable; urgency=medium

  * 6.0.78

 -- Wang Fei <wangfei@deepin.org>  Fri, 13 Dec 2024 13:46:35 +0800

dde-control-center (6.0.77) unstable; urgency=medium

  * fix: Fix incorrect page status after the update is completed
  * chore: adjust active colors
  * chore: keyboard translations tweak
  * chore: update datetime/language translations
  * chore: add keboard layout tips
  * chore(power): update translate
  * chore(personalization): update translate
  * fix: modify deepinid module display name
  * fix: have no input device,there are input titles and prompt texts (#1873)
  * fix: DBus adds asynchronous return processing
  * feat: add audio Mono (#1871)
  * chore: dcc focus tweak
  * Fix: update bluetooth translation
  * fix: wallpaper color selection is not effective
  * fix: region format init failed
  * fix: wrong lib install path
  * feat: Modify translation processing errors
  * chore: udpate keyboard shortcut translations
  * fix(personnalization): screen select combobox is empty
  * feat: Update menu item description
  * feat: add sound description (#1859)
  * chore: update date and time translations
  * chore(personalization): update activeColor list
  * fix: hidden developer mode (#1856)
  * fix: system/custom timezone datas affect each other
  * fix(power): The sliding bar scale value is incorrect
  * feat: update audio framework translations (#1853)
  * fix: Modifying DBus cannot redirect properly
  * feat: Add audio framework module (#1850)
  * feat: Update weight
  * feat: Update {name}Main translation
  * feat: Change main.qml to {name}Main.qm
  * fix: window effect no background
  * feat: Update display,notification,deepinid,wacom,touchscreen translation
  * chore: update power and personalization translations
  * chore: keyboard visble tweak
  * chore: update datetime/accounts translations
  * feat: Update translations for Bluetooth, General, System Information, Sound, etc.
  * chore: update power translations
  * feat: Update translation
  * chore: datetime translation tweak
  * chore: init ts files
  * fix: Modify update description (#1832)
  * fix: Update workflows.yml
  * fix(build): display module arm64 build failed
  * fix: Hide menu without touchpad
  * fix: font size error
  * fix: font Combobox is empty
  * fix: update deepinid description
  * feat: Add display module
  * feat: Update workflows.yml
  * fix: language set failed
  * fix: Setting activity color invalid
  * fix: Personalization module starts slowly in Treeland
  * feat: dcc deepinid module
  * fix: Create a new object when calling getSectionItem
  * fix: zoom shortcut filter tweak
  * chore: use AP instead of ap/Ap
  * fix: system timezone setting error
  * feat: Added initial version update function
  * feat: Treeland adaptation of personalized modules
  * feat: add the StartupWMClass field to the desktop file
  * fix: ntp server list can not scroll
  * fix: The hoverEnabled of DccItem defaults to true
  * feat: add current acount page
  * feat: add account module
  * chore: time date tweak
  * fix: loading plugin crashed
  * chore: time date display tweak
  * fix: Add DCI search path

 -- Zhangkun <zhangkun2@uniontech.com>  Fri, 06 Dec 2024 16:25:17 +0800

dde-control-center (6.0.76.2) unstable; urgency=medium

  * release 6.0.76.2

 -- Zhangkun <zhangkun2@uniontech.com>  Fri, 22 Nov 2024 11:18:36 +0800

dde-control-center (6.0.76.1) unstable; urgency=medium

  * fix: modify keyboard name(Task: 361721)

 -- caixiangrong <caixiangrong@uniontech.com>  Wed, 20 Nov 2024 16:09:40 +0800

dde-control-center (6.0.76) unstable; urgency=medium

  * feat: Implement notification module code(Task: 366517)
  * fix: Multiple creation issues with modifying plugin objects(Task: 361721)
  * feat: Improve the interface of the control center(Task: 361721)
  * fix: Add DccSetingsObject(Task: 361721)
  * fix: modify keyboard name(Task: 361721)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 20 Nov 2024 13:39:40 +0800

dde-control-center (6.0.75) unstable; urgency=medium

  * release 6.0.75

 -- xionglinlin <xionglinlin@uniontech.com>  Thu, 14 Nov 2024 10:00:17 +0800
 

=== debian/control ===
Source: dde-control-center
Section: admin
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends:
 debhelper-compat (= 12),
 pkg-config,
 cmake,
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-tools-dev,
 qt6-declarative-private-dev,
 qt6-multimedia-dev,
 libpolkit-qt6-1-dev,
 libdtkcommon-dev,
 libdtk6gui-dev(>=6.0.21),
 libdtk6core-dev,
 libdtk6core-bin,
 doxygen,
 libgtest-dev,
 extra-cmake-modules,
 libqt6svg6,
 deepin-gettext-tools,
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 qml6-module-qt-labs-qmlmodels,
 qt6-wayland-dev,
 qt6-wayland-private-dev,
 qt6-wayland-dev-tools,
 treeland-protocols(>=0.4.1),
 systemd,
 qtbase5-dev,
 qtbase5-private-dev,
 qttools5-dev-tools,
 libdtkwidget-dev,
 libdtkcore-dev(>>5.6.18),
 libdtkcore5-bin,
 qtmultimedia5-dev,
 libdareader-dev,
 libdeepin-pw-check-dev,
 libpolkit-qt5-1-dev,
 libgsettings-qt-dev,
 libicu-dev,
 libwayland-dev,
Standards-Version: 4.5.0
Homepage: https://github.com/linuxdeepin/dde-control-center

Package: dde-control-center
Architecture: any
Depends:
 ${shlibs:Depends}, ${misc:Depends},
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 qml6-module-qt-labs-qmlmodels,
 qml6-module-qtquick-dialogs,
 libdtk6declarative,
 netselect,
Description: New control center for Deepin Desktop Environment,
 Integrated control center with rich functions,Besides providing rich
 system setting items, the function level is simple, the logic is clear,
 the user can easily set the system, and the learning cost is low,
 Provide users with automatic update system and developer mode to meet
 the various needs of users for the operating system.
 abrecovery -restore system, Determine whether the system is restored
 reboot-reminder-dialog -Update restart, Confirm whether to restart the system
 after the completion of the update.
 DDE Control Center is the control panel of Deepin Desktop Environment.

Package: dde-control-center-dev
Architecture: any
Depends: dde-control-center (= ${binary:Version}), ${misc:Depends}
Description: New control center for Deepin Desktop Environment - development files
 DDE Control Center is the control panel of Deepin Desktop Environment.

Package: dde-control-center-doc
Architecture: any
Depends: dde-control-center (= ${binary:Version}), ${misc:Depends}
Description: dde-control-center (document)
 This package contains the doc files of dde-control-center

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export QT_SELECT = qt6
VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
%:
	dh $@ --parallel
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM) -DDVERSION=$(PACK_VER) -DUSE_DEEPIN_ZONE=ON

## dde-control-center 6.1.26

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,12 +16,12 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
-option(ENABLE_ASAN "Enable asan" OFF)
+set(ENABLE_ASAN OFF)
 option(BUILD_TESTING "UNIT test" OFF)
-set(BUILE_EXAMPLES OFF)
+set(BUILD_EXAMPLES OFF)
 
 # dcc-v23
-set(BUILD_DCC_OLD ON)
+set(BUILD_DCC_OLD OFF)
 if (BUILD_DCC_OLD)
     add_subdirectory(dcc-old)
 endif()
@@ -41,11 +41,9 @@
 # INFO:
 # plugins can be disabled and their options
 # plugin-authentication : DISABLE_AUTHENTICATION
-# plugin-update : DISABLE_UPDATE
 # plugin-keyboard: DISABLE_LANGUAGE to disable language panel
 
 option(DISABLE_AUTHENTICATION "disable build authentication plugins" OFF)
-option(DISABLE_UPDATE "disable build update plugins" OFF)
 option(DISABLE_LANGUAGE "disable lanugage settings in control center" OFF)
 option(USE_DEEPIN_ZONE "enable special timezone file on deepin" OFF)
 option(DISABLE_SOUND_ADVANCED "disable sound advanced settings" OFF)
@@ -60,8 +58,14 @@
     set(UNITTEST ON)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Werror=return-type -fno-omit-frame-pointer -Wextra")
     if(ENABLE_ASAN)
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
-        add_definitions(-DUSE_ASAN)
+        if (CMAKE_CXX_COMPILER_ID MATCHES "GNU"  OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -g")
+            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -g")
+            set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
+            set(CMAKE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS} -fsanitize=address")
+            set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address")
+            add_definitions(-DUSE_ASAN)
+        endif()
     endif()
 else()
     # generate qm
@@ -97,6 +101,14 @@
 add_definitions(-DLOCALE_I18N_PATH="${LOCALE_I18N_PATH}")
 
 # 增加安全编译参数
+set(POSITION_INDEPENDENT_CODE True)
+set(THREADS_PREFER_PTHREAD_FLAG ON)
+find_package(Threads REQUIRED)
+string(REGEX REPLACE "-D_FORTIFY_SOURCE=[0-9]*" "" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}" )
+string(REGEX REPLACE "-D_FORTIFY_SOURCE=[0-9]*" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}" )
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all -D_FORTIFY_SOURCE=3  -Wall -Wl,--as-need -Wl,-E")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all -D_FORTIFY_SOURCE=3  -Wall -Wl,--as-need -Wl,-E")
+set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -z relro -z now -z noexecstack")
 ADD_DEFINITIONS(${SAFE_COMPILER})
 
 # Install settings
@@ -194,6 +206,7 @@
 add_subdirectory(src/dde-control-center)
 #--------------------------plugins--------------------------
 add_subdirectory(src/plugin-accounts)
+add_subdirectory(src/plugin-authentication)
 add_subdirectory(src/plugin-sound)
 add_subdirectory(src/plugin-defaultapp)
 add_subdirectory(src/plugin-power)
@@ -206,12 +219,13 @@
 add_subdirectory(src/plugin-datetime)
 add_subdirectory(src/plugin-wacom)
 add_subdirectory(src/plugin-bluetooth)
-add_subdirectory(src/plugin-update)
 add_subdirectory(src/plugin-notification)
 add_subdirectory(src/plugin-deepinid)
 add_subdirectory(src/plugin-display)
-
-if(BUILE_EXAMPLES)
+add_subdirectory(src/plugin-privacy)
+add_subdirectory(src/plugin-dock)
+
+if(BUILD_EXAMPLES)
     add_subdirectory(examples)
 endif()

=== src/plugin-privacy/CMakeLists.txt ===
set(LIB_NAME privacy)

find_package(DDEShell REQUIRED)
find_package(PolkitQt6-1 REQUIRED)

pkg_check_modules(LIBDPKG REQUIRED libdpkg)
include_directories(${DPKG_INCLUDE_DIRS})

file(GLOB_RECURSE Privacy_SRCS
    "operation/*.cpp"
    "operation/*.hpp"
    "operation/*.h"
    "operation/qrc/privacy.qrc"
)

set(Privacy_Includes
    src/plugin-privacy/operation
)

add_library(${LIB_NAME} MODULE
    ${Privacy_SRCS}
    ${DBUS_INTERFACES}
)

set(Privacy_Libraries
    ${DCC_FRAME_Library}
    ${DTK_NS}::Gui
    ${QT_NS}::DBus
    ${QT_NS}::Qml
    ${QT_NS}::Concurrent
    Dde::Shell
    PolkitQt6-1::Agent
    dpkg
)

target_include_directories(${LIB_NAME} PUBLIC
    ${Privacy_Includes}
)

target_link_libraries(${LIB_NAME} PRIVATE
    ${Privacy_Libraries}
)

dcc_install_plugin(NAME ${LIB_NAME} TARGET ${LIB_NAME})

=== debian/changelog ===
dde-control-center (6.1.26) unstable; urgency=medium

  * fix: ensure plain text format in KeySequenceDisplay
  * fix: Correct spelling errors
  * fix: improve sound device combo box dynamic sizing
  * fix: disable power management features in virtual environments
  * fix: adjust device page plugin order
  * fix: The application name contains the deepin character
  * fix: Fix the issue of names that are too long not being truncated.
  * fix: improve language label display in LangsChooserDialog
  * fix: Fix the display issue of the new creation failure interface.
  * fix: disable focus on shortcut operation buttons
  * fix: Modify custom time rules
  * fix(auth): adjust unreasonable UI

 -- xionglinlin <xionglinlin@uniontech.com>  Thu, 15 May 2025 22:05:47 +0800

dde-control-center (6.1.25) unstable; urgency=medium

  * fix: Modifying settings for copying mode issues
  * fix: Fix the hyperlink issue in the user interface
  * fix: Fix Bluetooth rename prompt error
  * fix: correct week start day format index
  * fix: Fix text style
  * fix: Fix the button text display issue
  * fix: hide play button background
  * fix: improve datetime format handling for non-Chinese locales
  * i18n: Updates for project Deepin Desktop Environment (#2244)
  * fix: preserve original language data in LanguageListModel

 -- YeShanShan <yeshanshan@uniontech.com>  Tue, 13 May 2025 16:28:40 +0800

dde-control-center (6.1.24) unstable; urgency=medium

  * fix: optimize slider behavior in sound control center
  * fix: improve country name translation in datetime module
  * fix: update mouse double-click speed slider labels
  * fix: Fixed the issue that hyperlinks did not have context menus
  * fix: Fixed the Bluetooth switch issue in airplane mode
  * fix: Fixed the lack of hover effect for list items
  * fix: Modify the height of the sidebar item
  * fix: improve time format handling in datetime model
  * feat:  adapt to WallpaperChanged signal
  * fix: Modify and check password strength issues
  * fix: Add keyboard_language generation script
  * i18n: Updates for project Deepin Desktop Environment (#2233)
  * fix: Fix layout errors
  * fix: update font in ShortcutSettingDialog
  * fix: Fixed the issue that the rename was empty
  * i18n: Updates for project Deepin Desktop Environment (#2229)

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 08 May 2025 16:44:23 +0800

dde-control-center (6.1.23) unstable; urgency=medium

  * fix: Add new language translation
  * fix: The issue of abnormal mouse style is fixed
  * fix: clear filter wildcard in LangsChooserDialog when deactivated
  * fix: failed to retrieve search results for grand searching
  * fix: Fixed the issue that the test content was not cleared
  * fix: adjust icon size in LangAndFormat component
  * fix: update locale in currentTime()
  * fix: Fixed the error of opening the default path
  * i18n: Updates for project Deepin Desktop Environment (#2218)
  * fix: update system time zone check in addUserTimeZone method
  * fix: Fixed the issue that the error content did not disappear
  * fix: add setFirstDayOfWeek call in setCurrentFormat
  * fix: Fixed the background exception of mouse operation
  * fix: resolve display issues in TimeAndDate component
  * fix: Modify the width of the strong reminder box
  * fix: Update Chinese translation
  * fix: Fixed that the password was empty and could still be determined
  * feat: DccCheckIcon defaults to checked status
  * fix: Modify search term configuration
  * fix: enhance SearchableListViewPopup and TimeAndDate components
  * fix: Fixed the issue that Bluetooth was renamed to empty
  * fix: Fixed the error issue of changing the full name
  * fix: Fixed the issue of waiting for Bluetooth to be turned on and
    off
  * fix: The issue of setting the background of grub startup is fixed

 -- YeShanShan <yeshanshan@uniontech.com>  Tue, 29 Apr 2025 13:16:21 +0800

dde-control-center (6.1.22) unstable; urgency=medium

  * fix: Display window only when DBus calls ShowPage
  * fix: Update error messages for camera occupancy
  * i18n: Updates for project Deepin Desktop Environment (#2198)
  * fix: add stopSoundEffectPlayback method and integrate into SoundEffectsPage
  * fix: Fixed the Bluetooth list loading issue
  * i18n: Updates for project Deepin Desktop Environment (#2194)
  * fix: Can be renamed to a duplicate name
  * fix: update sound effects and animations for theme support
  * fix: Fixed the Bluetooth name display issue

 -- caixiangrong <caixiangrong@uniontech.com>  Tue, 22 Apr 2025 15:52:20 +0800

dde-control-center (6.1.21) unstable; urgency=medium

  * fix: Compatible with previous command parameters
  * fix: Return hierarchy error
  * fix: Return hierarchy error
  * fix: use system locale for date formatting
  * fix: Add translation language types
  * fix: use system locale for date formatting
  * fix: Added error sounds
  * fix: Modify the translation loading location
  * fix: The title is displayed incorrectly.
  * fix: Add secure compilation parameters
  * i18n: Updates for project Deepin Desktop Environment (#2171)
  * fix: improve timezone selection persistence in search
  * fix: The issue of user group editing is fixed
  * fix: always include switch-monitors in system shortcuts filter
  * fix: Fixed the Bluetooth checkbox clicking issue
  * fix: simplify NTP server validation and address assignment
  * fix: missing unchecked state for DccCheckIcon
  * fix: ScorllBar still hide when hovered
  * feat: Support the user agreement for UosMilitary
  * fix: copyright cannot display Chinese
  * fix: Add the computer name tooltip
  * i18n: Updates for project Deepin Desktop Environment (#2168)
  * fix: Fixed the issue of formula bar style
  * fix: The issue that the username is displayed too long is fixed
  * fix: The issue that the group title is not refreshed in time is fixed
  * fix: disable microphone input level slider interaction
  * i18n: Updates for project Deepin Desktop Environment (#2156)



=== debian/control ===
--- 
+++ 
@@ -29,19 +29,13 @@
  qt6-wayland-dev-tools,
  treeland-protocols(>=0.4.1),
  systemd,
- qtbase5-dev,
- qtbase5-private-dev,
- qttools5-dev-tools,
- libdtkwidget-dev,
- libdtkcore-dev(>>5.6.18),
- libdtkcore5-bin,
- qtmultimedia5-dev,
  libdareader-dev,
  libdeepin-pw-check-dev,
- libpolkit-qt5-1-dev,
- libgsettings-qt-dev,
  libicu-dev,
  libwayland-dev,
+ libssl-dev,
+ libdde-shell-dev(> 1.99.19),
+ libdpkg-dev
 Standards-Version: 4.5.0
 Homepage: https://github.com/linuxdeepin/dde-control-center
 
@@ -55,6 +49,8 @@
  qml6-module-qtquick-dialogs,
  libdtk6declarative,
  netselect,
+Conflicts: dde-control-center-dock
+Replaces: dde-control-center-dock
 Description: New control center for Deepin Desktop Environment,
  Integrated control center with rich functions,Besides providing rich
  system setting items, the function level is simple, the logic is clear,
